Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.fdk
Class ManagersFactory

    java.lang.Object
      oracle.ifs.fdk.ManagersFactory

Direct Known Subclasses:
  InProcessManagersFactory

    public abstract class ManagersFactory

extends java.lang.Object

An abstract factory that returns instances of Oracle Content DB Manager classes, which serve as the entry point for accessing and using a Content DB instance.

Instances of this factory will return the appropriate Manager instances based on the environment from which it is being used, such as from an in-process server plug-in or from a remote web-services connection.

Instances of this factory are associated with a specific session and require credentials to be instantiated. Instances are obtained via the various `login()` static methods.

When a client no longer needs an instance of this class, it must call `logout()` so that the implementation can release any allocated resources. Failure to do so may result in sessions being kept alive forever.

THREAD SAFETY NOTE: The consumer of these objects must not assume that the implementations of this class are thread safe, though some may be. Because each instance returned by the `login()` methods and instances of the Managers returned by the methods in this class are usually associated with a user session, the calling code should ensure that proper synchronization is done when calling the methods of this class or calling the methods of the Managers returned by this class. Please see the Java Memory Model (JSR-133) for more information.

Field Summary
`static java.lang.String` | `CONFIG_SERVER_VERSION` The optional configuration parameter that can be passed to the underlying implementation in the configuration map, representing the server version the client is trying to connect to.
`protected static java.lang.String` | `CONFIG_WS_URL` The Web Services URL configuration property name passed to the implementation subclass in the Map configuration.

Constructor Summary
`protected` | `ManagersFactory(java.util.Map config)` Protected constructor.

Method Summary
`abstract void` | `beginRequest(java.lang.String tag)` Marks the begining of a request that will result in successive calls to various managers and their methods.
`abstract void` | `endRequest()` Marks the end of a request.
`abstract ArchiveManager` | `getArchiveManager()` Returns the ArchiveManager instance.
`abstract AuditManager` | `getAuditManager()` Returns The AuditManager instance.
`abstract CategoryManager` | `getCategoryManager()` Returns The CategoryManager instance.
`abstract CommonManager` | `getCommonManager()` Returns the CommonManager instance.
`abstract ContainerManager` | `getContainerManager()` Returns the ContainerManager instance.
`abstract ContentManager` | `getContentManager()` Returns The ContentManager instance.
`abstract DomainManager` | `getDomainManager()` Returns the DomainManager instance.
`abstract FileContentManager` | `getFileContentManager()` Returns the FileContentManager instance.
`abstract FileManager` | `getFileManager()` Returns the FileManager instance.
`abstract GroupManager` | `getGroupManager()` Returns the GroupManager instance.
`abstract LifecycleManager` | `getLifecycleManager()` Returns The LifecycleManager instance.
`abstract LockManager` | `getLockManager()` Returns the LockManager instance.
`abstract RelationManager` | `getRelationManager()` Returns The RelationManager instance.
`abstract RequestManager` | `getRequestManager()` Returns the RequestManager instance.
`abstract SearchManager` | `getSearchManager()` Returns the SearchManager instance.
`abstract SecurityManager` | `getSecurityManager()` Returns the SecurityManager instance.
`abstract SessionManager` | `getSessionManager()` Returns the SessionManager instance.
`abstract SortManager` | `getSortManager()` Returns the SortManager instance.
`abstract SystemConfigurationManager` | `getSystemConfigurationManager()` Returns the SystemConfigurationManager instance.
`abstract TrashManager` | `getTrashManager()` Returns the TrashManager instance.
`abstract Item` | `getUser(AttributeRequest[] attributes)` Returns the user as an Item that was authenticated for this instance.
`abstract UserManager` | `getUserManager()` Returns the UserManager instance.
`abstract VersionManager` | `getVersionManager()` Returns the VersionManager instance.
`abstract WorkflowManager` | `getWorkflowManager()` Returns the WorkflowManager instance.
`abstract WorkspaceManager` | `getWorkspaceManager()` Returns the WorkspaceManager instance.
`abstract boolean` | `isInProcess()` Returns true if the instance is running in-process, false if it is running remoted over Web Services.
`static ManagersFactory` | `login(FdkCredential credential)` Returns an authenticated instance for use by in-process clients only.
`static ManagersFactory` | `login(FdkCredential credential, java.lang.String wsUrl)` Returns an authenticated instance for use by either remoted clients over Web Services if an URL is provided or in-process clients if the URL is `null`.
`static ManagersFactory` | `login(FdkCredential credential, java.lang.String className, boolean ws, java.util.Map config)` Returns an authenticated instance with a custom configuration.
`static ManagersFactory` | `login(FdkCredential credential, java.lang.String wsUrl, java.util.Map config)` Returns an authenticated instance for use by either remoted clients over Web Services if an URL is provided or in-process clients if the URL is `null`.
`abstract void` | `logout()` The counterpart of the `login()` methods.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CONFIG_SERVER_VERSION

    public static final java.lang.String CONFIG_SERVER_VERSION

  Description copied from class: `ManagersFactory`
  The optional configuration parameter that can be passed to the underlying implementation in the configuration map, representing the server version the client is trying to connect to. This is mainly used when connecting over Web Services. Not all underlying implementations may support this parameter or they may support only specific version values. The value is of the form 10.1.2.x.x, 10.1.3.x.x but the implementation may also support major version only such as 10.1.2, 10.1.3, etc.

### CONFIG_WS_URL

    protected static final java.lang.String CONFIG_WS_URL

  Description copied from class: `ManagersFactory`
  The Web Services URL configuration property name passed to the implementation subclass in the Map configuration. The value is guaranteed to be non-`null` and it represents the URL of the server to connect to, e.g. `http://localhost:7777/content/ws`

Constructor Detail

### ManagersFactory

    protected ManagersFactory(java.util.Map config)
                       throws FdkException

  Protected constructor.

  Throws:
    `FdkException`

Method Detail

### login

    public static ManagersFactory login(FdkCredential credential,
                                        java.lang.String wsUrl)
                                 throws FdkException

  Description copied from class: `ManagersFactory`
  Returns an authenticated instance for use by either remoted clients over Web Services if an URL is provided or in-process clients if the URL is `null`.

  Parameters:
    `credential` - The credential to use for authentication. Required.
    `wsUrl` - The web services URL of the server to connect to, e.g. `http://localhost:7777/content/ws`
    If `null`, the in-process instance is returned, which is equivalent to calling `ManagersFactory.login(FdkCredential)`
  Throws:
    `FdkException`

### login

    public static ManagersFactory login(FdkCredential credential,
                                        java.lang.String wsUrl,
                                        java.util.Map config)
                                 throws FdkException

  Description copied from class: `ManagersFactory`
  Returns an authenticated instance for use by either remoted clients over Web Services if an URL is provided or in-process clients if the URL is `null`. Additionally, configuration parameters for the underlying implementation may be provided.

  Parameters:
    `credential` - The credential to use for authentication. Required.
    `wsUrl` - The web services URL of the server to connect to, e.g. `http://localhost:7777/content/ws`
    If `null`, the in-process instance is returned, which is equivalent to calling `ManagersFactory.login(FdkCredential)`
    `config` - The custom configuration parameters. Optional.
  Throws:
    `FdkException`

### login

    public static ManagersFactory login(FdkCredential credential)
                                 throws FdkException

  Description copied from class: `ManagersFactory`
  Returns an authenticated instance for use by in-process clients only.

  Note that this method returns an instance of `oracle.ifs.fdk.InProcessManagersFactory` and it is safe to cast to it in order to use its additional functionality.

  Parameters:
    `credential` - The credential to use for authentication. Required.
  Throws:
    `FdkException`

### login

    public static ManagersFactory login(FdkCredential credential,
                                        java.lang.String className,
                                        boolean ws,
                                        java.util.Map config)
                                 throws FdkException

  Description copied from class: `ManagersFactory`
  Returns an authenticated instance with a custom configuration.

  Parameters:
    `credential` - The credential to use for authentication. Required.
    `className` - The fully qualified class name of the implementation subclass of this class. It must declare a `public Constructor(FdkCredential credential, Map config)`
    `ws` - Specifies whether the implementation class is to be used over Web Services (`true`) or in-process (`false`).
    `config` - The custom configuration parameters. Optional.
  Throws:
    `FdkException`
  (Unpublished)

### isInProcess

    public abstract boolean isInProcess()

  Description copied from class: `ManagersFactory`
  Returns true if the instance is running in-process, false if it is running remoted over Web Services.

### beginRequest

    public abstract void beginRequest(java.lang.String tag)
                               throws FdkException

  Description copied from class: `ManagersFactory`
  Marks the begining of a request that will result in successive calls to various managers and their methods. It is required to call this method on HTTP request boundaries for example so that it is ensured that resources are allocated and guaranteed to be available for the duration of request processing. At then end of the request, `endRequest()` must be called so that the resources are properly disposed of.

  Note that after the instance is obtained by a `login()` call, one must not call this method, the request can be considered already in progress and the resources are ready to use.

  This method does not support multiple successive calls without a call to `endRequest()` in between or an exception will be raised.

  Parameters:
    `tag` - A tag that an application must use to identify itself and that can be used for statistics purposes. Must not be `null`.
  Throws:
    `FdkException`

### endRequest

    public abstract void endRequest()
                             throws FdkException

  Description copied from class: `ManagersFactory`
  Marks the end of a request. See `beginRequest()`.

  Throws:
    `FdkException`

### logout

    public abstract void logout()
                         throws FdkException

  Description copied from class: `ManagersFactory`
  The counterpart of the `login()` methods.

  Logs out any underlying session and disposes the resources allocated by this instance.

  Clients must call this method when the instance is no longer needed (i.e. when the user session needs to be terminated).

  Throws:
    `FdkException`

### getUser

    public abstract Item getUser(AttributeRequest[] attributes)
                          throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the user as an Item that was authenticated for this instance. Additional attributes of the user can be requested.

  Parameters:
    `attributes` - Optional attributes to return. Can be `null`.
  Throws:
    `FdkException`

### getCommonManager

    public abstract CommonManager getCommonManager()
                                            throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the CommonManager instance.

  Returns:
    The CommonManager instance.
  Throws:
    `FdkException`

### getFileManager

    public abstract FileManager getFileManager()
                                        throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the FileManager instance.

  Returns:
    The FileManager instance.
  Throws:
    `FdkException`

### getLifecycleManager

    public abstract LifecycleManager getLifecycleManager()
                                                  throws FdkException

  Description copied from class: `ManagersFactory`
  Returns The LifecycleManager instance.

  Returns:
    The LifecycleManager instance.
  Throws:
    `FdkException`

### getSessionManager

    public abstract SessionManager getSessionManager()
                                              throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the SessionManager instance.

  Returns:
    The SessionManager instance.
  Throws:
    `FdkException`

### getArchiveManager

    public abstract ArchiveManager getArchiveManager()
                                              throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the ArchiveManager instance.

  Returns:
    The ArchiveManager instance.
  Throws:
    `FdkException`

### getAuditManager

    public abstract AuditManager getAuditManager()
                                          throws FdkException

  Description copied from class: `ManagersFactory`
  Returns The AuditManager instance.

  Returns:
    The AuditManager instance.
  Throws:
    `FdkException`

### getCategoryManager

    public abstract CategoryManager getCategoryManager()
                                                throws FdkException

  Description copied from class: `ManagersFactory`
  Returns The CategoryManager instance.

  Returns:
    The CategoryManager instance.
  Throws:
    `FdkException`

### getContainerManager

    public abstract ContainerManager getContainerManager()
                                                  throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the ContainerManager instance.

  Returns:
    The ContainerManager instance.
  Throws:
    `FdkException`

### getDomainManager

    public abstract DomainManager getDomainManager()
                                            throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the DomainManager instance.

  Returns:
    The DomainManager instance.
  Throws:
    `FdkException`

### getGroupManager

    public abstract GroupManager getGroupManager()
                                          throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the GroupManager instance.

  Returns:
    The GroupManager instance.
  Throws:
    `FdkException`

### getLockManager

    public abstract LockManager getLockManager()
                                        throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the LockManager instance.

  Returns:
    The LockManager instance.
  Throws:
    `FdkException`

### getContentManager

    public abstract ContentManager getContentManager()
                                              throws FdkException

  Description copied from class: `ManagersFactory`
  Returns The ContentManager instance.

  Returns:
    The ContentManager instance.
  Throws:
    `FdkException`

### getRelationManager

    public abstract RelationManager getRelationManager()
                                                throws FdkException

  Description copied from class: `ManagersFactory`
  Returns The RelationManager instance.

  Returns:
    The RelationManager instance.
  Throws:
    `FdkException`

### getRequestManager

    public abstract RequestManager getRequestManager()
                                              throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the RequestManager instance.

  Returns:
    The RequestManager instance.
  Throws:
    `FdkException`

### getSearchManager

    public abstract SearchManager getSearchManager()
                                            throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the SearchManager instance.

  Returns:
    The SearchManager instance.
  Throws:
    `FdkException`

### getSecurityManager

    public abstract SecurityManager getSecurityManager()
                                                throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the SecurityManager instance.

  Returns:
    The SecurityManager instance.
  Throws:
    `FdkException`

### getSortManager

    public abstract SortManager getSortManager()
                                        throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the SortManager instance.

  Returns:
    The SortManager instance.
  Throws:
    `FdkException`

### getSystemConfigurationManager

    public abstract SystemConfigurationManager getSystemConfigurationManager()
                                                                      throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the SystemConfigurationManager instance.

  Returns:
    The SystemConfigurationManager instance.
  Throws:
    `FdkException`

### getTrashManager

    public abstract TrashManager getTrashManager()
                                          throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the TrashManager instance.

  Returns:
    The TrashManager instance.
  Throws:
    `FdkException`

### getUserManager

    public abstract UserManager getUserManager()
                                        throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the UserManager instance.

  Returns:
    The UserManager instance.
  Throws:
    `FdkException`

### getVersionManager

    public abstract VersionManager getVersionManager()
                                              throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the VersionManager instance.

  Returns:
    The VersionManager instance.
  Throws:
    `FdkException`

### getWorkflowManager

    public abstract WorkflowManager getWorkflowManager()
                                                throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the WorkflowManager instance.

  Returns:
    The WorkflowManager instance.
  Throws:
    `FdkException`

### getWorkspaceManager

    public abstract WorkspaceManager getWorkspaceManager()
                                                  throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the WorkspaceManager instance.

  Returns:
    The WorkspaceManager instance.
  Throws:
    `FdkException`

### getFileContentManager

    public abstract FileContentManager getFileContentManager()
                                                      throws FdkException

  Description copied from class: `ManagersFactory`
  Returns the FileContentManager instance.

  Returns:
    The FileContentManager instance.
  Throws:
    `FdkException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD